local cvt       = default.convert_node
local reg_alias = ocutil.safe_register_alias

local modname   = minetest.get_current_modname()
local modpath   = minetest.get_modpath (modname)

cvt ("mydoorsplus:castle_door13_a"                    ,
        "my_castle_doors:door13_a"                    )
cvt ("mydoorsplus:castle_door13_b"                    ,
        "my_castle_doors:door13_b"                    )

cvt ("mydoorsplus:castle_door2_a"                     ,
        "my_castle_doors:door2_a"                     )
cvt ("mydoorsplus:castle_door2_b"                     ,
        "my_castle_doors:door2_b"                     )

cvt ("mydoorsplus:castle_door6_a"                     ,
        "my_castle_doors:door6_a"                     )
cvt ("mydoorsplus:castle_door6_b"                     ,
        "my_castle_doors:door6_b"                     )

cvt ("mydoorsplus:cottage_door1_a"                    ,
        "my_cottage_doors:door1_a"                    )
cvt ("mydoorsplus:cottage_door1_b"                    ,
        "my_cottage_doors:door1_b"                    )

-- TBD: Review: 156, 23, -151
cvt ("mydoorsplus:fancy_door6_a"                      ,
        "my_fancy_doors:door6_a"                      )
cvt ("mydoorsplus:fancy_door6_b"                      ,
        "my_fancy_doors:door6_b"                      )

cvt ("mydoorsplus:fancy_door7_a"                      ,
        "my_fancy_doors:door7_a"                      )
cvt ("mydoorsplus:fancy_door7_b"                      ,
        "my_fancy_doors:door7_b"                      )

cvt ("mydoorsplus:future_door2a"                      ,
        "my_future_doors:door2a"                      )
cvt ("mydoorsplus:future_door2b"                      ,
        "my_future_doors:door2b"                      )
cvt ("mydoorsplus:future_door3a"                      ,
        "my_future_doors:door3a"                      )
cvt ("mydoorsplus:future_door3b"                      ,
        "my_future_doors:door3b"                      )

cvt (   "mydoorsplus:hidden_door_stone_a"             ,
     "my_hidden_doors:hidden_doorstone_a"             )

cvt (   "mydoorsplus:hidden_door_wood_a"              ,
     "my_hidden_doors:hidden_doorwood_a"              )

cvt (   "mydoorsplus:hidden_door_bookshelf_a"         ,
     "my_hidden_doors:hidden_doorbookshelf_a"         )
cvt (   "mydoorsplus:hidden_door_bookshelf_b"         ,
     "my_hidden_doors:hidden_doorbookshelf_b"         )

cvt ("mydoorsplus:misc_door2_a"                       ,
        "my_misc_doors:door2_a"                       )
cvt ("mydoorsplus:misc_door2_b"                       ,
        "my_misc_doors:door2_b"                       )

cvt ("mydoorsplus:misc_door3_a"                       ,
        "my_misc_doors:door3_a"                       )
cvt ("mydoorsplus:misc_door3_b"                       ,
        "my_misc_doors:door3_b"                       )

-- There doesn't  seem to be a  "door6" in "my_misc_doors".  So, we'll
-- use "door4" here instead.

cvt ("mydoorsplus:misc_door6_a"                       ,
        "my_misc_doors:door4_a"                       )
cvt ("mydoorsplus:misc_door6_b"                       ,
        "my_misc_doors:door4_b"                       )

cvt (   "mydoorsplus:hidden_door_sandstone_brick_a"   ,
     "my_hidden_doors:hidden_doorsandstone_brick_a"   )
cvt (   "mydoorsplus:hidden_door_sandstone_brick_b"   ,
     "my_hidden_doors:hidden_doorsandstone_brick_b"   )

cvt ("mydoorsplus:old_door1_a"                        ,
        "my_old_doors:door1_a"                        )
cvt ("mydoorsplus:old_door1_b"                        ,
        "my_old_doors:door1_b"                        )

cvt ("mydoorsplus:old_door2_a"                        ,
        "my_old_doors:door2_a"                        )
cvt ("mydoorsplus:old_door2_b"                        ,
        "my_old_doors:door2_b"                        )

cvt (         "yadm:door_wd3_a"                       ,
        "my_yadm_doors:door6_a"                       )
cvt (         "yadm:door_wd3_b"                       ,
        "my_yadm_doors:door6_b"                       )

-- ===================================================================

cvt ("mydoorsplus:saloon_doora_black"                 ,
       "my_saloon_doors:door1a_black"                 )

cvt ("mydoorsplus:saloon_doora_brown"                 ,
       "my_saloon_doors:door1a_brown"                 )

cvt ("mydoorsplus:saloon_doora_dark_grey"             ,
       "my_saloon_doors:door1a_dark_grey"             )

cvt ("mydoorsplus:saloon_doora_yellow"                ,
       "my_saloon_doors:door1a_yellow"                )

-- ===================================================================

-- Future: 3672,44,-3839
-- These are a special case that requires an LBM:
-- mydoorsplus:sliding_barsa
-- mydoorsplus:sliding_barsb
