-- ===================================================================

local safe_register_alias = ocutil.safe_register_alias

local nodepart
local neednode
local fromnode

local targetmod
local baselist
local modlist

-- ===================================================================

nodepart = "brickblock_multicolor_dark"
neednode = "stairs:slab_"   .. nodepart
fromnode = "unifiedbricks:" .. nodepart
--
if  default.dont_reduce_node_count              and
    minetest.registered_nodes [neednode] == nil and
    minetest.registered_nodes [fromnode] ~= nil then

    stairs.register_all (nodepart, fromnode,
    { cracky=3, not_in_creative_inventory=1          } ,
    { "unifiedbricks_brickblock_multicolor_dark.png" } ,
    "Brick Block MultiDark"                            ,
    default.node_sound_stone_defaults())
end

-- ===================================================================
-- End of module.
