-- ===================================================================

local cvt = default.convert_node

-- ===================================================================

local greeklist = {
    "gilded_gold_block"             ,
    "marble_cobble"                 ,
    "marble_tile"                   ,
    "pillar"                        ,
    "pillar_head_corinthian"        ,
    "pillar_head_dioric"            ,
    "pillar_head_ionic"             ,
    "polished_marble"               ,
    "polished_marble_block"         ,
}

for k,v in pairs (greeklist) do
    cvt ("dimondmod:"  .. v ,
         "greeknodes:" .. v )
end

-- ===================================================================

cvt ( "dimondmod:birthday_gift_small_"      ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:birthday_gift_small_2"     ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:christmas_gift_small_"     ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:christmas_gift_small_2"    ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:christmas_gift_large_"     ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:birthday_gift_large_2"     ,
     "xmas:present_meta"                    )
cvt ( "dimondmod:windchime"                 ,
     "windchimes:windchime"                 )

-- ===================================================================
-- End of file.
